<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_error".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanError".
 *
 * Columns in table "scan_error" available as properties of the model,
 * followed by relations of table "scan_error" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_error_report_id
 * @property integer $scan_result_practice_id
 * @property integer $scan_result_provider_id
 * @property string $date_added
 * @property string $date_updated
 * @property string $status_id
 * @property string $date_verified
 * @property integer $verifier_account
 *
 * @property ScanErrorReport $scanErrorReport
 * @property ScanResultPractice $scanResultPractice
 * @property ScanResultProvider $scanResultProvider
 * @property Status $status
 * @property Account $verifierAccount
 * @property ScanErrorDetail[] $scanErrorDetails
 * @property ScanErrorLog[] $scanErrorLogs
 * @property ScanErrorTask[] $scanErrorTasks
 */
abstract class BaseScanError extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_error';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanError|ScanErrors', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('scan_error_report_id', 'required'),
            array('scan_error_report_id, scan_result_practice_id, scan_result_provider_id, verifier_account', 'numerical', 'integerOnly'=>true),
            array('status_id', 'length', 'max'=>10),
            array('date_added, date_updated, date_verified', 'safe'),
            array('scan_result_practice_id, scan_result_provider_id, date_added, date_updated, status_id, date_verified, verifier_account', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_error_report_id, scan_result_practice_id, scan_result_provider_id, date_added, date_updated, status_id, date_verified, verifier_account', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanErrorReport' => array(self::BELONGS_TO, 'ScanErrorReport', 'scan_error_report_id'),
            'scanResultPractice' => array(self::BELONGS_TO, 'ScanResultPractice', 'scan_result_practice_id'),
            'scanResultProvider' => array(self::BELONGS_TO, 'ScanResultProvider', 'scan_result_provider_id'),
            'status' => array(self::BELONGS_TO, 'Status', 'status_id'),
            'verifierAccount' => array(self::BELONGS_TO, 'Account', 'verifier_account'),
            'scanErrorDetails' => array(self::HAS_MANY, 'ScanErrorDetail', 'scan_error_id'),
            'scanErrorLogs' => array(self::HAS_MANY, 'ScanErrorLog', 'scan_error_id'),
            'scanErrorTasks' => array(self::HAS_MANY, 'ScanErrorTask', 'scan_error_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_error_report_id' => null,
            'scan_result_practice_id' => null,
            'scan_result_provider_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'status_id' => null,
            'date_verified' => Yii::t('app', 'Date Verified'),
            'verifier_account' => null,
            'scanErrorReport' => null,
            'scanResultPractice' => null,
            'scanResultProvider' => null,
            'status' => null,
            'verifierAccount' => null,
            'scanErrorDetails' => null,
            'scanErrorLogs' => null,
            'scanErrorTasks' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_error_report_id', $this->scan_error_report_id);
        $criteria->compare('scan_result_practice_id', $this->scan_result_practice_id);
        $criteria->compare('scan_result_provider_id', $this->scan_result_provider_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('status_id', $this->status_id);
        $criteria->compare('date_verified', $this->date_verified, true);
        $criteria->compare('verifier_account', $this->verifier_account);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
